using System;
using System.Collections.Generic;
using System.Text;
using InfiniTec.Exchange;
using System.IO;
using InfiniTec.Exchange.WebDav;
using InfiniTec.Threading;
using System.Threading;
using InfiniTec.Exchange.WebDav.Request;

namespace ExampleApplication.Example
{
    [View("Create item", "WebDAV low-level operations")]
    class CreateItem: ExampleBase
    {
        private System.Windows.Forms.Button btnCreate;
        private System.Windows.Forms.Label label2;
        private System.Windows.Forms.TextBox tbContent;
        private System.Windows.Forms.ListBox lbLog;

        private Stream _Stream;

        public CreateItem()
        {
            InitializeComponent();
        }
        private void InitializeComponent()
        {
            this.tbContent = new System.Windows.Forms.TextBox();
            this.btnCreate = new System.Windows.Forms.Button();
            this.label2 = new System.Windows.Forms.Label();
            this.lbLog = new System.Windows.Forms.ListBox();
            this.SuspendLayout();
            // 
            // tbContent
            // 
            this.tbContent.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
                        | System.Windows.Forms.AnchorStyles.Left)
                        | System.Windows.Forms.AnchorStyles.Right)));
            this.tbContent.Location = new System.Drawing.Point(11, 51);
            this.tbContent.Multiline = true;
            this.tbContent.Name = "tbContent";
            this.tbContent.ScrollBars = System.Windows.Forms.ScrollBars.Vertical;
            this.tbContent.Size = new System.Drawing.Size(599, 161);
            this.tbContent.TabIndex = 2;
            // 
            // btnCreate
            // 
            this.btnCreate.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
            this.btnCreate.Location = new System.Drawing.Point(538, 218);
            this.btnCreate.Name = "btnCreate";
            this.btnCreate.Size = new System.Drawing.Size(75, 23);
            this.btnCreate.TabIndex = 3;
            this.btnCreate.Text = "&Create";
            this.btnCreate.UseVisualStyleBackColor = true;
            this.btnCreate.Click += new System.EventHandler(this.btnCreate_Click);
            // 
            // label2
            // 
            this.label2.AutoSize = true;
            this.label2.Location = new System.Drawing.Point(8, 35);
            this.label2.Name = "label2";
            this.label2.Size = new System.Drawing.Size(47, 13);
            this.label2.TabIndex = 4;
            this.label2.Text = "Content:";
            // 
            // lbLog
            // 
            this.lbLog.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)
                        | System.Windows.Forms.AnchorStyles.Right)));
            this.lbLog.FormattingEnabled = true;
            this.lbLog.Location = new System.Drawing.Point(11, 247);
            this.lbLog.Name = "lbLog";
            this.lbLog.Size = new System.Drawing.Size(599, 95);
            this.lbLog.TabIndex = 5;
            // 
            // CreateItem
            // 
            this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
            this.Controls.Add(this.lbLog);
            this.Controls.Add(this.btnCreate);
            this.Controls.Add(this.label2);
            this.Controls.Add(this.tbContent);
            this.Name = "CreateItem";
            this.Size = new System.Drawing.Size(613, 349);
            this.Controls.SetChildIndex(this.tbContent, 0);
            this.Controls.SetChildIndex(this.label2, 0);
            this.Controls.SetChildIndex(this.btnCreate, 0);
            this.Controls.SetChildIndex(this.lbLog, 0);
            this.ResumeLayout(false);
            this.PerformLayout();

        }

        private void btnCreate_Click(object sender, EventArgs e)
        {
            Item item;
           
            item = GetItem();
            item.SetContentProgressChanged += item_SetContentProgressChanged;
            item.SetContentCompleted += item_SetContentCompleted;

            _Stream = new MemoryStream(Encoding.UTF8.GetBytes(tbContent.Text));

            item.SetContentAsync(_Stream);
        }
  
        void item_SetContentCompleted(object sender, System.ComponentModel.AsyncCompletedEventArgs e)
        {
            _Stream = null;

            Invoke((ThreadStart)delegate
            {
                if (e.Error != null)
                {
                    ViewManager.ShowException(e.Error);
                    return;
                }

                lbLog.Items.Add("Finished. Cancelled: " + e.Cancelled);
            });
        }

        void item_SetContentProgressChanged(object sender, InfiniTec.Threading.ProgressChangedEventArgs<RequestStatus> e)
        {
             Invoke((ThreadStart)delegate
            {
               lbLog.Items.Add(e.Status.ToString());
            });
        }

        protected Item GetItem()
        {
            Item item = new Item(RootPath, ConnectionView.Connection);

            return item;
        }
    }
}
