using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using InfiniTec.Exchange;
using InfiniTec.Threading;
using System.IO;
using System.Threading;
using InfiniTec.Exchange.WebDav.Request;
using InfiniTec.Exchange.WebDav;

namespace ExampleApplication.Example
{
    [View("Get Mime Content", "WebDAV low-level operations")]
    public partial class GetMimeContent : ExampleApplication.Example.ExampleBase
    {
        MemoryStream _Stream;


        public GetMimeContent()
        {
            InitializeComponent();
        }

        private void btnDownload_Click(object sender, EventArgs e)
        {
            Item item;

            item = GetItem();

            item.GetContentProgressChanged += item_GetContentProgressChanged;
            item.GetContentCompleted += item_GetContentCompleted;

            _Stream = new MemoryStream();
            item.GetContentAsync(_Stream);
        }

        void item_GetContentCompleted(object sender, AsyncCompletedEventArgs e)
        {
            Invoke((ThreadStart)delegate
            {
                if (e.Error != null)
                {
                    ViewManager.ShowException(e.Error);
                    return;
                }

                tbContent.Text = Encoding.ASCII.GetString(_Stream.GetBuffer(), 0, (int) _Stream.Length);

                lbLog.Items.Add("Finished. Cancelled: " + e.Cancelled);
            });
        }

        void item_GetContentProgressChanged(object sender, ProgressChangedEventArgs<RequestStatus> e)
        {
            Invoke((ThreadStart)delegate
            {
                lbLog.Items.Add(e.Status.ToString());
            });
        }

        protected Item GetItem()
        {
            Item item = new Item(RootPath, ConnectionView.Connection);

            return item;
        }
    }
}

