using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Text;
using System.Windows.Forms;
using InfiniTec.Exchange;
using InfiniTec.Exchange.WebDav;

namespace ExampleApplication.Example
{
    public partial class PropertyDisplay: UserControl
    {
        private Item _Item;

        public Item Item
        {
            get { return _Item; }
            set { 
                _Item = value;
                DisplayResult();
            }
        }

        protected void DisplayResult()
        {
            cbProperties.Items.Clear();

            if (Item == null) return;

            foreach (Property p in Item.Properties)
            {
                cbProperties.Items.Add(p);
            }
            if (cbProperties.Items.Count > 0)
            {
                cbProperties.SelectedIndex = 0;
            }
        }
        private void cbProperties_SelectedIndexChanged(object sender, EventArgs e)
        {
            pgProperties.SelectedObject = cbProperties.SelectedItem;
        }
        public PropertyDisplay()
        {
            InitializeComponent();
        }
    }
}
