using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Text;
using System.Windows.Forms;
using System.Reflection;
using InfiniTec.Exchange;

namespace ExampleApplication.Example
{
    public partial class PropertySelector: UserControl
    {
        public string[] Properties
        {
            get {
                string[] props;

                props = new string[lbProperties.Items.Count];
                for (int i = 0; i < lbProperties.Items.Count; i++)
                {
                    props[i] = (string) lbProperties.Items[i];
                }

                return props;
            }
        }

        public PropertySelector()
        {
            InitializeComponent();

            InitializePropertyAutoComplete();
            
        }

        private void InitializePropertyAutoComplete()
        {
            List<string> items;

            if (tbProperty.AutoCompleteCustomSource.Count != 0) return;

            items = new List<string>();

            foreach (FieldInfo info in typeof(Namespaces).GetFields(BindingFlags.Public | BindingFlags.Static))
            {
                items.Add((string) info.GetValue(null));
            }
            items.Sort();

            tbProperty.AutoCompleteCustomSource.AddRange(items.ToArray());
        }

        private void bnAdd_Click(object sender, EventArgs e)
        {
            lbProperties.Items.Add(tbProperty.Text);
            tbProperty.Text = "";
        }

        private void tbProperty_TextChanged(object sender, EventArgs e)
        {
            btnAdd.Enabled = (!string.IsNullOrEmpty(tbProperty.Text));
        }

        private void lbProperties_SelectedIndexChanged(object sender, EventArgs e)
        {
            btnRemove.Enabled = (lbProperties.SelectedItems.Count > 0);
        }

        private void btnRemove_Click(object sender, EventArgs e)
        {
            for (int i = lbProperties.SelectedIndices.Count - 1; i >= 0; i--)
            {
                lbProperties.Items.RemoveAt(lbProperties.SelectedIndices[i]);
            }
        }
    }
}
