using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using InfiniTec.Exchange;
using System.Security.AccessControl;
using InfiniTec.Exchange.Security;
using InfiniTec.Security;
using InfiniTec.Exchange.WebDav;

namespace ExampleApplication.Example
{
    [View("Read security descriptor", "WebDAV low-level operations")]
    public partial class ReadSecurityDescriptor: ExampleApplication.Example.ExampleBase
    {
        public ReadSecurityDescriptor()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
           listView1.Items.Clear();

            switch (chkOpenAsFolder.Checked)
            {
                case false:
                    Item item = new Item(RootPath, ConnectionView.Connection);
                    item.Refresh();
                    ItemSecurity isecurity = item.GetSecurity();
                    
                    foreach (ItemAce entry in isecurity.GetAccessControlEntries())
                    {
                        AddItem(entry);
                    }
                    break;
                case true:
                    Folder folder = new Folder(RootPath, ConnectionView.Connection);
                    folder.Refresh();
                    FolderSecurity fsecurity = folder.GetSecurity();

                    foreach (FolderAce entry in fsecurity.GetAccessControlEntries())
                    {
                        AddItem(entry);
                    }
                    break;
            }

            if (listView1.Items.Count == 0) return;
        }

        private void AddItem(ItemAce entry)
        {
            ListViewItem item;
            IdentityResolver account;


            account = new IdentityResolver(entry.IdentityReference, ConnectionView.Connection.Server);
            item = new ListViewItem();
            try
            {
                item.Text = account.Account.Value;
                item.SubItems.Add(account.AccountType.ToString());
            }
            catch
            {
                item.Text = entry.IdentityReference.ToString();
                item.SubItems.Add("");
            }
            item.Tag = entry;
            if (entry is FolderAce)
            {
                item.SubItems.Add(((FolderAce) entry).Role.ToString());
            }
            listView1.Items.Add(item);
        }

        private void listView1_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (listView1.SelectedItems.Count > 0)
            {
                propertyGrid1.SelectedObject = listView1.SelectedItems[0].Tag;
            }
        }
    }
}

