using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Text;
using System.Windows.Forms;
using System.Reflection;
using InfiniTec.Exchange;
using InfiniTec.Exchange.WebDav;

namespace ExampleApplication.Example
{
    [View("Retrieve properties", "WebDAV low-level operations")]
    public partial class RetrieveProperties: ExampleBase
    {
        public RetrieveProperties()
        {
            InitializeComponent();
        }

        private void btnLoad_Click(object sender, EventArgs e)
        {
            LoadValues();
        }

        protected virtual void LoadValues()
        {
            Item item = CreateItem();

            item.Refresh();
            propertyDisplay.Item = item;
        }



        protected Item CreateItem()
        {
            Item item = new Item(RootPath, ConnectionView.Connection);
            foreach (string entry in propertySelector1.Properties)
            {
                item.PropertiesToLoad.Add(entry);
            }
            return item;
        }
     
    }
}
