using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using InfiniTec.Exchange;
using InfiniTec.Threading;
using System.Threading;
using InfiniTec.Exchange.WebDav.Request;
using InfiniTec.Exchange.WebDav;

namespace ExampleApplication.Example
{
    [View("Retrieve properties (Async)", "WebDAV low-level operations")]
    public partial class RetrievePropertiesAsync: RetrieveProperties
    {
        Item item;

        public RetrievePropertiesAsync()
        {
            InitializeComponent();
        }

        protected override void LoadValues()
        {
            item = CreateItem();

            lbProgress.Items.Clear();

            item.RefreshCompleted += item_RefreshCompleted;
            item.RefreshProgressChanged += item_RefreshProgressChanged;

            item.RefreshAsync();
        }

        void item_RefreshProgressChanged(object sender, ProgressChangedEventArgs<RequestStatus> e)
        {
            Invoke((ThreadStart) delegate {
                lbProgress.Items.Add(e.Status.ToString());
            });
        }

        void item_RefreshCompleted(object sender, AsyncCompletedEventArgs e)
        {
            Invoke((ThreadStart) delegate
            {
                if (e.Error != null)
                {
                    ViewManager.ShowException(e.Error);
                    return;
                }

                lbProgress.Items.Add("Finished. Cancelled: " + e.Cancelled);
                propertyDisplay.Item = item;
            });
        }
    }
}

