using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using InfiniTec.Exchange;
using InfiniTec.Exchange.WebDav;

namespace ExampleApplication.Example
{
    [View("Search items", "WebDAV low-level operations")]
    public partial class SearchItems: ExampleApplication.Example.ExampleBase
    {
        public SearchItems()
        {
            InitializeComponent();
        }

        private void btnSearch_Click(object sender, EventArgs e)
        {
            DoSearch();
        }

        protected virtual void DoSearch()
        {
            Searcher searcher;

            searcher = CreateSearcher();

            searcher.Scope = SearchScope.Hierarchical;

            searcher.Find();

            DisplayResults(searcher.SearchResult);
        }

        protected void DisplayResults(IList<Item> items)
        {
            cbItems.Items.Clear();
            foreach (Item item in items)
            {
                cbItems.Items.Add(item);
            }
            if (cbItems.Items.Count > 0)
            {
                cbItems.SelectedIndex = 0;
            }
        }

        protected virtual Searcher CreateSearcher()
        {
            Searcher searcher;
            
            searcher = new Searcher(RootPath, ConnectionView.Connection);
            searcher.Scope = (SearchScope) Enum.Parse(typeof(SearchScope), (string) cbScope.SelectedItem);
            foreach (string item in propertySelector.Properties)
            {
                searcher.PropertiesToLoad.Add(item);
            }
            searcher.Constraints = tbConstraint.Text;

            return searcher;
        }

        private void SearchItems_Load(object sender, EventArgs e)
        {
            cbScope.SelectedIndex = 0;
        }

        private void cbItems_SelectedIndexChanged(object sender, EventArgs e)
        {
            propertyDisplay1.Item = (Item) cbItems.SelectedItem;
        }
    }
}

