using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using InfiniTec.Exchange;
using System.Threading;
using InfiniTec.Threading;
using InfiniTec.Exchange.WebDav;

namespace ExampleApplication.Example
{
    [View("Search items (Async)", "WebDAV low-level operations")]
    public partial class SearchItemsAsync : SearchItems
    {
        Searcher searcher;

        public SearchItemsAsync()
        {
            InitializeComponent();
        }

        protected override void DoSearch()
        {
            searcher = CreateSearcher();

            searcher.ProgressChanged += searcher_ProgressChanged;
            searcher.Completed += searcher_Completed;

            searcher.FindAsync();
        }

        void searcher_Completed(object sender, AsyncCompletedEventArgs e)
        {
            Invoke((ThreadStart)delegate
            {
                if (e.Error != null)
                {
                    ViewManager.ShowException(e.Error);
                    return;
                }
                lbProgress.Items.Add("Finished. Cancelled: " + e.Cancelled);

                DisplayResults(searcher.SearchResult);
            });
        }

        void searcher_ProgressChanged(object sender, SearchProgressChangedEventArgs e)
        {
            string s;

            Invoke((ThreadStart)delegate
            {
                if (e.Range != null)
                {
                    s = string.Format(" Range: {0}-{1}", e.Range.From, e.Range.To);
                }
                else
                {
                    s = "";
                }

                lbProgress.Items.Add(s);

                foreach (Item item in searcher.SearchResult)
                {
                    lbProgress.Items.Add("    " + item.Url.ToString());
                }

            });
        }
    }
}

