using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace ExampleApplication
{
    public partial class ExceptionDialog: Form
    {
        private Exception _Exception;

        public Exception Exception
        {
            get { return _Exception; }
            set { _Exception = value; UpdateUI(); }
        }

        private void UpdateUI()
        {
            Exception ex;

            cbExceptions.Items.Clear();

            ex = Exception;
            while (ex != null)
            {
                cbExceptions.Items.Add(ex);
                ex = ex.InnerException;
            }
        }

        public ExceptionDialog()
        {
            InitializeComponent();
        }

        private void cbExceptions_SelectedIndexChanged(object sender, EventArgs e)
        {
            Exception ex;

            if (cbExceptions.SelectedItem == null) {
                tbDetails.Text = "";
            }

            ex = (Exception) cbExceptions.SelectedItem;
            tbDetails.Text = ex.ToString();
            propertyGrid1.SelectedObject = ex;
        }

        private void ExceptionDialog_Load(object sender, EventArgs e)
        {
            if (cbExceptions.Items.Count == 0) return;

            cbExceptions.SelectedIndex = 0;
        }
    }
}